// Coord.cpp: implementation of the CCoord class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "engine.h"
#include "ReMaic Studio.h"
#include "Coord.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCoord::CCoord()
{
	time[0] = 0;
	time[1] = 0;
	time[2] = 0;
	offset[0] = 0;
	offset[1] = 0;
	offset[2] = 0;
	entity[0] = 0;
	entity[1] = 0;
	entity[2] = 0;
}

CCoord::~CCoord()
{
}

CCoord CCoord::operator= (char* string)
{
	CString TXT[3],temp;
	char* ptr1 = string;
	char* ptr2 = string;
	BOOL single = FALSE;
	while (*ptr2 && *ptr2 != ' ')
		ptr2++;
	if (!*ptr2)
		single = TRUE;
	*ptr2 = '\0';
	TXT[0] = ptr1;
	ptr1 = ++ptr2;
	while (*ptr2 != ' ' && *ptr2 != '\0')
		ptr2++;
	if (ptr2 == '\0')
		TXT[1] = "";
	else
	{
		*ptr2 = '\0';
		TXT[1] = ptr1;
	}
	ptr1 = ++ptr2;
	while (*ptr2 != ' ' && *ptr2 != '\0')
		ptr2++;
	if (ptr2 == '\0')
		TXT[2] = "";
	else
	{
		*ptr2 = '\0';
		TXT[2] = ptr1;
	}
	if (single)
		TXT[2] = TXT[1] = TXT[0];

	for (int i = 0; i < 3;i++)
	{
		if (TXT[i].FindOneOf("~+-") > -1 && TXT[i].GetAt(0) != '-')
		{
			temp = TXT[i].Left(TXT[i].FindOneOf("~+-"));
			if (temp == "p")
				entity[i] = 1;
			else if (temp.GetAt(0) == 'n')
			{
				entity[i] = -1;
			}
			else
			{
				entity[i] = atoi(LPCSTR(temp)+1);
			}
			int pos = TXT[i].FindOneOf("~+-");
			TXT[i] = (LPCSTR(TXT[i]) + pos);
			if (TXT[i].GetAt(0) == '~')
			{
				time[i] = (float)atof(LPCSTR(TXT[i]) + 1);
			}
			else
			{
				offset[i] = (float)atof(LPCSTR(TXT[i]));
			}
		}
		else
		{
			if (TXT[i] == "now")
			{
				entity[i] = -1;
			}
			else if (TXT[i] == "p")
			{
				entity[i] = 1;
			}
			else if (TXT[i].GetAt(0) == 'e')
			{
				entity[i] = atoi(LPCSTR(TXT[i])+1);
			}
			else
				offset[i] = (float)atof(LPCSTR(TXT[i]));
		}
		if (entity[i] != -1)
			interest[entity[i]] = TRUE;
	}

	return *this;
}

void CCoord::value(float result[3])
{
	for (int i = 0 ; i < 3 ; i++)
	{
		if (entity[i]!= -1)
			result[i] = offset[i];
		if (entity[i] > 0)
		{
			EntPosList* list;
			list = &(positions[entity[i]]);
			if (!list->IsEmpty())
			{
				POSITION pos = list->GetHeadPosition();
				float t = list->GetAt(pos).time;
				while (t > (cur_time - time[i]) && pos)
				{
					list->GetNext(pos);
					if (pos)
						t = list->GetAt(pos).time;
				}
				if (pos)
					result[i] += list->GetAt(pos).origin[i];
			}
		}
	}
}
