// ReMaic StudioDlg.cpp : implementation file
//


#define INI_FILE "remstud.ini"

#include <process.h>
#include <stdio.h>

#include "stdafx.h"
#include "engine.h"
#include "command.h"
#include "ReMaic Studio.h"
#include "ReMaic StudioDlg.h"
#include "splash.h"
#include "script.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern BOOL problems;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReMaicStudioDlg dialog

CReMaicStudioDlg::CReMaicStudioDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CReMaicStudioDlg::IDD, pParent)
{
	m_sync = TRUE;
	m_quit = FALSE;
	m_Batch= FALSE;
	//{{AFX_DATA_INIT(CReMaicStudioDlg)
	m_generate = TRUE;
	m_play = TRUE;
	m_dest = _T("");
	m_script = _T("");
	m_source = _T("");
	m_color = FALSE;
	m_addtext = FALSE;
	m_print_time = FALSE;
	m_remove_cprint = TRUE;
	m_remove_text = TRUE;
	m_remove_stufftext = TRUE;
	m_chain = FALSE;
	m_addblood = TRUE;
	m_next = _T("");
	m_fade = TRUE;
	m_minusv = FALSE;
	m_exittime = TRUE;
	m_runner = _T("");
	m_filmer = _T("");
	m_set_fps = FALSE;
	m_fps = 20;
	m_pan = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CReMaicStudioDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReMaicStudioDlg)
	DDX_Control(pDX, EDT_FPS, m_ctrl_fps);
	DDX_Control(pDX, CMB_SHIRT, m_shirt);
	DDX_Control(pDX, CMB_PANTS, m_pants);
	DDX_Control(pDX, EDT_FILMER, m_ctlr_filmer);
	DDX_Control(pDX, EDT_RUNNER, m_ctrl_runner);
	DDX_Control(pDX, EDT_CHAIN, m_ctrl_next);
	DDX_Control(pDX, EDT_SOURCE, m_source_ctrl);
	DDX_Check(pDX, CHK_GENERATE, m_generate);
	DDX_Check(pDX, CHK_PLAY, m_play);
	DDX_Text(pDX, EDT_DEST, m_dest);
	DDX_Text(pDX, EDT_SCRIPT, m_script);
	DDX_Text(pDX, EDT_SOURCE, m_source);
	DDX_Check(pDX, CHK_COLOR, m_color);
	DDX_Check(pDX, CHK_ADDTEXT, m_addtext);
	DDX_Check(pDX, CHK_ADDTIME, m_print_time);
	DDX_Check(pDX, CHK_REMOVECPRINT, m_remove_cprint);
	DDX_Check(pDX, CHK_REMOVEBPRINT, m_remove_text);
	DDX_Check(pDX, CHK_REMOVESTUFFTEXT, m_remove_stufftext);
	DDX_Check(pDX, CHK_LINK, m_chain);
	DDX_Check(pDX, CHK_BLOOD, m_addblood);
	DDX_Text(pDX, EDT_CHAIN, m_next);
	DDX_Check(pDX, CHK_FADE, m_fade);
	DDX_Check(pDX, CHK_MINUSV, m_minusv);
	DDX_Check(pDX, CHK_EXITTIME, m_exittime);
	DDX_Text(pDX, EDT_RUNNER, m_runner);
	DDX_Text(pDX, EDT_FILMER, m_filmer);
	DDX_Check(pDX, CHK_FPS, m_set_fps);
	DDX_Text(pDX, EDT_FPS, m_fps);
	DDV_MinMaxInt(pDX, m_fps, 5, 100);
	DDX_Check(pDX, IDC_PAN, m_pan);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReMaicStudioDlg, CDialog)
	//{{AFX_MSG_MAP(CReMaicStudioDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BTN_BROWSE, OnBrowse)
	ON_BN_CLICKED(BTN_QUIT, OnQuit)
	ON_EN_CHANGE(EDT_SOURCE, OnChangeSource)
	ON_EN_CHANGE(EDT_DEST, OnChangeDest)
	ON_BN_CLICKED(BTN_GO, OnGo)
	ON_EN_KILLFOCUS(EDT_SOURCE, OnKillfocusSource)
	ON_BN_CLICKED(CHK_COLOR, OnColor)
	ON_BN_CLICKED(CHK_ADDTEXT, OnAddtext)
	ON_BN_CLICKED(CHK_PLAY, OnPlay)
	ON_BN_CLICKED(CHK_LINK, OnLink)
	ON_EN_KILLFOCUS(EDT_SCRIPT, OnKillfocusScript)
	ON_BN_CLICKED(CHK_FPS, OnFps)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReMaicStudioDlg message handlers

BOOL CReMaicStudioDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_pants.SetCurSel(4);
	m_shirt.SetCurSel(0);

	for (int I = 0; I < 256; I++)
	{
		sounds[I] = models[I] = 0;
	}

	if (!m_Batch)
	{
		char buffer[80];

		GetPrivateProfileString("General","source","e1m1.dem",buffer,80,INI_FILE);
			m_source = buffer;
		GetPrivateProfileString("General","script","temp.cam",buffer,80,INI_FILE);
			m_script = buffer;
		GetPrivateProfileString("General","destination","e1m1c.dem",buffer,80,INI_FILE);
			m_dest = buffer;
		GetPrivateProfileString("General","generate","True",buffer,80,INI_FILE);
			m_generate = !strcmp(buffer,"True");
		GetPrivateProfileString("General","autoplay","True",buffer,80,INI_FILE);
			m_play = !strcmp(buffer,"True");


		GetPrivateProfileString("Add","print time","False",buffer,80,INI_FILE);
			m_print_time = !strcmp(buffer,"True");
		GetPrivateProfileString("Add","fade","True",buffer,80,INI_FILE);
			m_fade= !strcmp(buffer,"True");
		GetPrivateProfileString("Add","exit time","True",buffer,80,INI_FILE);
			m_exittime= !strcmp(buffer,"True");
		GetPrivateProfileString("Add","blood","True",buffer,80,INI_FILE);
			m_addblood= !strcmp(buffer,"True");

		GetPrivateProfileString("Remove","centerprint","True",buffer,80,INI_FILE);
			m_remove_cprint= !strcmp(buffer,"True");
		GetPrivateProfileString("Remove","text","True",buffer,80,INI_FILE);
			m_remove_text= !strcmp(buffer,"True");
		GetPrivateProfileString("Remove","stufftext","True",buffer,80,INI_FILE);
			m_remove_stufftext= !strcmp(buffer,"True");
		GetPrivateProfileString("Remove","FOV","False",buffer,80,INI_FILE);
			m_minusv= !strcmp(buffer,"True");


		UpdateData(FALSE);

		m_source_ctrl.SetSel(0,m_source.GetLength());
		CSplashWnd::ShowSplashScreen(this);

	}
	else
		OnGo();


	return TRUE; // return TRUE unless you set the focus to a control
}

void CReMaicStudioDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CReMaicStudioDlg::OnDestroy()
{
	WinHelp(0L, HELP_QUIT);
	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CReMaicStudioDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CReMaicStudioDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CReMaicStudioDlg::OnBrowse() 
{
	CFileDialog dialog(TRUE);
	UpdateData();
	dialog.m_ofn.lpstrFilter = "Quake demo files\0*.dem\0";
	dialog.m_ofn.Flags |= OFN_FILEMUSTEXIST | 
						  OFN_HIDEREADONLY |
						  OFN_NOCHANGEDIR;
	if (dialog.DoModal() == IDOK)
	{
		m_source = dialog.GetFileName();
	}
	if (m_sync)
	{
		m_dest = m_source.Left(m_source.Find('.')) + "c.dem";
	}
	UpdateData(FALSE);
}

void CReMaicStudioDlg::OnQuit() 
{
	if (MessageBox("Are you sure ?","Quiting ReMaic Studio",MB_ICONQUESTION | MB_YESNO)
		== IDYES)
	{
		UpdateData();

		WritePrivateProfileString("General","source",m_source,INI_FILE);
		WritePrivateProfileString("General","script",m_script,INI_FILE);
		WritePrivateProfileString("General","generate",(m_generate?"True":"False"),INI_FILE);
		WritePrivateProfileString("General","destination",m_dest,INI_FILE);
		WritePrivateProfileString("General","autoplay",(m_play?"True":"False"),INI_FILE);

		WritePrivateProfileString("Add","print time",(m_print_time?"True":"False"),INI_FILE);
		WritePrivateProfileString("Add","fade",(m_fade?"True":"False"),INI_FILE);
		WritePrivateProfileString("Add","exit time",(m_exittime?"True":"False"),INI_FILE);
		WritePrivateProfileString("Add","blood",(m_addblood?"True":"False"),INI_FILE);

		WritePrivateProfileString("Remove","centerprint",(m_remove_cprint?"True":"False"),INI_FILE);
		WritePrivateProfileString("Remove","text",(m_remove_text?"True":"False"),INI_FILE);
		WritePrivateProfileString("Remove","stufftext",(m_remove_stufftext?"True":"False"),INI_FILE);
		WritePrivateProfileString("Remove","FOV",(m_minusv?"True":"False"),INI_FILE);

		for (int I = 0; I < 256; I++)
		{
			if (models[I])
				delete[] models[I];
			if (sounds[I])
				delete[] sounds[I];
		}
		EndDialog(IDCANCEL);
	}
}

void CReMaicStudioDlg::OnChangeSource() 
{
	UpdateData();
	if (m_sync)
	{
		if (m_source.Find('.') == -1)
		{
			m_dest = m_source + 'c';
		}
		else
			m_dest = m_source.Left(m_source.Find('.')) + "c.dem";
	}
	UpdateData(FALSE);
}

void CReMaicStudioDlg::OnChangeDest() 
{
	m_sync = m_source.IsEmpty();
}

BOOL exists(CString filename)
{
	if (filename.IsEmpty())
		return FALSE;
	FILE* f = fopen(LPCTSTR(filename),"r");
	if (f)
	{
		fclose(f);
		return TRUE;
	}
	return FALSE;
}

#define WriteBlock(dst,destination) \
	if (dst.m_size)\
		dst.Write(destination);

extern float printed_time;
void CReMaicStudioDlg::OnGo() 
{
	printed_time = 0;
	refilming = TRUE;
	finished = FALSE;
	m_last_frame = 0;
	m_prev_frame = 0;
	UpdateData();
	if (m_source.IsEmpty())
	{
		MessageBox( "You must specify a source file.",
			"Error",MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (m_dest.IsEmpty())
	{
		MessageBox( "You must specify a destination file.",
			"Error",MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (!exists(m_source))
	{
		MessageBox( "The source file \"" + m_source + "\" doesn't exist",
			"Error",MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (m_script.IsEmpty())
	{
		MessageBox( "You must specify a script file",
			"Error",MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (!exists(m_script) && !m_generate)
	{
		MessageBox( "The script file \"" + m_script + "\" doesn't exist",
			"Error",MB_ICONEXCLAMATION | MB_OK);
		return;
	}

	refilming = FALSE;
	if (m_generate)
		generate((char*)LPCSTR(m_source),(char*)LPCSTR(m_script));
	refilming = TRUE;
	cur_time = 0;

	CBlock src,dst;
	dst.Reset();
	ifstream source;
	ifstream script;
	ofstream destination;

	script.open(LPCSTR(m_script));
	for (int i = 0 ; i < 450; i++)
		interest[i] = FALSE;	

	while (!finished)
		CCommand::ReadLine(script);

	OrderList(roll);
	OrderList(palette);
	OrderList(target);
	OrderList(movement);
	OrderList(misc);


	source.open(LPCSTR(m_source),ios::binary);
	destination.open(LPCSTR(m_dest),ios::binary);

	source.flags(0);
	char c = '\n';
	do 
		source >> c;
	while (c != '\n');
	destination << "-1\n";

	inter_time = 0;
	src.Read(source);
	float old_t = 1.35,t;

	while (strcmp(src.m_buffer,"ABCDEFG") && 
		((inter_time == 0 || cur_time < inter_time + 5) || !m_fade))
	{
		t = src.GetBlockTime();
		if (!t || scale == 1)
		{

			Process(src,dst);
			if (dst.m_size >= 1450); // fixme : treat it


			WriteBlock(dst,destination);

			if (!misc.IsEmpty() )
			{
				float t = misc.GetHead().m_time;
				if (t <= cur_time)
				{
					dst.Reset();

					if (misc.GetHead().type == "print")
					{
						dst.PutByte(0x08);
						strcpy(buffer,LPCSTR(misc.GetHead().text));
						dst.PutString();
						misc.RemoveHead();
					}
					else if (misc.GetHead().type == "centerprint")
					{
						dst.PutByte(0x1A);
						strcpy(buffer,LPCSTR(misc.GetHead().text));
						dst.PutString();
						misc.RemoveHead();
					}
					else if (misc.GetHead().type == "stufftext")
					{
						dst.PutByte(0x09);
						strcpy(buffer,LPCSTR(misc.GetHead().text));
						dst.PutString();
						misc.RemoveHead();
					}
					else if (misc.GetHead().type == "finale")
					{
						dst.PutByte(0x1F);
						strcpy(buffer,LPCSTR(misc.GetHead().text));
						dst.PutString();
						misc.RemoveHead();
					}
					else if (misc.GetHead().type == "sound")
					{
						byte mask = 0;
						if (misc.GetHead().G != 1)
							mask |= 1;
						if (misc.GetHead().R != 2)
							mask |= 2;
						dst.PutByte (0x06);
						dst.PutByte (mask);
						if (mask & 1)
						{
							dst.PutByte ((byte)(misc.GetHead().G * 255));
						}
						if (mask & 2)
						{
							dst.PutByte ((byte)(misc.GetHead().R * 64));
						}
						dst.PutShort((short)(misc.GetHead().end_time*8+misc.GetHead().B));
						dst.PutByte ((byte)(misc.GetHead().data));
						vec3_t coord;
						if (misc.GetHead().end_time==449)
						{
							coord[0] = cam_pos[0];
							coord[1] = cam_pos[1];
							coord[2] = cam_pos[2];
						}
						else if (!positions[(int)(misc.GetHead().end_time)].IsEmpty())
						{
							coord[0] = positions[(int)(misc.GetHead().end_time)].GetHead().origin[0];
							coord[1] = positions[(int)(misc.GetHead().end_time)].GetHead().origin[1];
							coord[2] = positions[(int)(misc.GetHead().end_time)].GetHead().origin[2];
						}
						for (i = 0;i<3;i++)
						{
							dst.PutShort((short)(coord[i]/0.125));
						}



						misc.RemoveHead();

					}
					if (dst.m_size)
						WriteBlock(dst,destination);
				}
			}

			if (t)
				old_t = t;
		}
		else
		{
			float sc = scale;
			if (qdqscale)
				sc = qdqscale;
/*			while ((t - old_t) > (0.05 / sc))
			{
				src.SetBlockTime(old_t);
				src.m_buffptr = src.m_buffer;
				old_t += 0.05 / sc;
				Process(src,dst);
				WriteBlock(dst,destination);
			}*/
			while ((t - old_t) > (sc))
			{
				old_t += sc;
				src.SetBlockTime(old_t);
				src.m_buffptr = src.m_buffer;
				Process(src,dst);
				WriteBlock(dst,destination);
			}
			src.SetBlockTime(t);
			old_t = t;
		}
		Process(src,dst);
		WriteBlock(dst,destination);

		if (!misc.IsEmpty() )
		{
			float t = misc.GetHead().m_time;
			if (t <= cur_time)
			{
				dst.Reset();

				if (misc.GetHead().type == "print")
				{
					dst.PutByte(0x08);
					strcpy(buffer,LPCSTR(misc.GetHead().text));
					dst.PutString();
					misc.RemoveHead();
				}
				else if (misc.GetHead().type == "centerprint")
				{
					dst.PutByte(0x1A);
					strcpy(buffer,LPCSTR(misc.GetHead().text));
					dst.PutString();
					misc.RemoveHead();
				}
				else if (misc.GetHead().type == "stufftext")
				{
					dst.PutByte(0x09);
					strcpy(buffer,LPCSTR(misc.GetHead().text));
					dst.PutString();
					misc.RemoveHead();
				}
				else if (misc.GetHead().type == "finale")
				{
					dst.PutByte(0x1F);
					strcpy(buffer,LPCSTR(misc.GetHead().text));
					dst.PutString();
					misc.RemoveHead();
				}
				else if (misc.GetHead().type == "sound")
				{
					byte mask = 0;
					if (misc.GetHead().G != 1)
						mask |= 1;
					if (misc.GetHead().R != 2)
						mask |= 2;
					dst.PutByte (0x06);
					dst.PutByte (mask);
					if (mask & 1)
					{
						dst.PutByte ((byte)(misc.GetHead().G * 255));
					}
					if (mask & 2)
					{
						dst.PutByte ((byte)(misc.GetHead().R * 64));
					}
					dst.PutShort((short)(misc.GetHead().end_time*8+misc.GetHead().B));
					dst.PutByte ((byte)(misc.GetHead().data));
					vec3_t coord;
					if (misc.GetHead().end_time==449)
					{
						coord[0] = cam_pos[0];
						coord[1] = cam_pos[1];
						coord[2] = cam_pos[2];
					}
					else if (!positions[(int)(misc.GetHead().end_time)].IsEmpty())
					{
						coord[0] = positions[(int)(misc.GetHead().end_time)].GetHead().origin[0];
						coord[1] = positions[(int)(misc.GetHead().end_time)].GetHead().origin[1];
						coord[2] = positions[(int)(misc.GetHead().end_time)].GetHead().origin[2];
					}
					for (i = 0;i<3;i++)
					{
						dst.PutShort((short)(coord[i]/0.125));
					}
					misc.RemoveHead();

				}
				if (dst.m_size)
					WriteBlock(dst,destination);
			}
		}

		src.Read(source);
	}

	dst.Reset();
	if (m_chain)
	{
		dst.PutByte(0x09); // stufftext;
		strcpy (buffer,"playdemo ");
		strcat (buffer,LPCSTR(m_next));
		strcat (buffer,"\n");
		dst.PutString();
	}
	dst.PutByte (0x02); // disconnect
	dst.Write(destination);
	
	if (problems)
		MessageBox("There were problems refilming " + m_source + " to "
						+ m_dest + ". However, the movie may be playable.",
						"Done",MB_ICONINFORMATION | MB_OK);
	else if (!m_Batch && !m_play)
			MessageBox(m_source + " refilmed to "
							+ m_dest + " succesfully.",
							"Done",MB_ICONINFORMATION | MB_OK);

	source.close();
	script.close();
	destination.close();

	if (m_play && !m_Batch)
	{
		char com[80] = "play ";
		strcat (com,LPCSTR(m_dest));
		system ( com);
	}
	roll.RemoveAll();
	palette.RemoveAll();
	target.RemoveAll();
	movement.RemoveAll();
	misc.RemoveAll();

	if (m_Batch)
		EndDialog(IDCANCEL);
}


void CReMaicStudioDlg::OnKillfocusSource() 
{
	UpdateData();
	if (m_source.IsEmpty())
		return;
	if (m_source.Find('.') == -1)
	{
		m_dest = m_source + "c.dem";
		m_source += ".dem";
	}
	else
		m_dest = m_source.Left(m_source.Find('.')) + "c.dem";
	UpdateData(FALSE);
}


void CReMaicStudioDlg::OnColor() 
{
	UpdateData();
	if (m_color)
	{
		// enable them
		m_pants.EnableWindow();
		m_shirt.EnableWindow();
	}
	else
	{
		// disable them
		m_pants.EnableWindow(FALSE);
		m_shirt.EnableWindow(FALSE);
	}
}

void CReMaicStudioDlg::OnAddtext() 
{
	UpdateData();
	if (m_addtext)
	{
		m_ctrl_runner.EnableWindow();
		m_ctlr_filmer.EnableWindow();
	}
	else
	{
		m_ctrl_runner.EnableWindow(FALSE);
		m_ctlr_filmer.EnableWindow(FALSE);
	}
}

void CReMaicStudioDlg::OnPlay() 
{
	UpdateData();
/*	if (m_play)
	{
		m_prop.EnableWindow();
	}
	else
		m_prop.EnableWindow(FALSE);*/
}

BOOL CReMaicStudioDlg::PreCreateWindow(CREATESTRUCT& cs) 
{
	return CDialog::PreCreateWindow(cs);
}

void CReMaicStudioDlg::OnLink() 
{
	UpdateData();
	if (m_chain)
	{
		m_ctrl_next.EnableWindow();
	}
	else
		m_ctrl_next.EnableWindow(FALSE);	
}

void CReMaicStudioDlg::OnKillfocusScript() 
{
	UpdateData();
	if (m_script.IsEmpty())
	{
		m_script = "example.cam";
	}
	else if (m_script.Find('.') == -1)
	{
		m_script = m_script + ".cam";
	}
	UpdateData(FALSE);	
}

void CReMaicStudioDlg::OnFps() 
{
	UpdateData();
	if (m_set_fps)
	{
		m_ctrl_fps.EnableWindow();
	}
	else
		m_ctrl_fps.EnableWindow(FALSE);
}

